CREATE OR REPLACE PACKAGE BODY pedido AS
  /**********************************************************************
  **                                                                   **
  ** Procedure MENU                                                    **
  **                                                                   **
  ** Menu principal del paquete de gestion de pedidos                  **
  **                                                                   **
  ** Invoca: Nada                                                      **
  **                                                                   **
  **********************************************************************/
  PROCEDURE menu IS
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Sistema de gestion de pedidos - Menu pedido');
    htp.headClose;
    htp.bodyOpen(cattributes => 'background="/icons/sgp/fondo_2.jpg"
                                 text=#ffffff link=#ffffff vlink=#e8e8e8');

    htp.hr;
    -- El menu del paquete "stock".
    htp.print(htf.anchor('stock.menu',
              htf.bold('<i>Stocks</i>'), cattributes => 'target="Left"'));
    htp.br;

    -- El menu de clientes.
    htp.print(htf.anchor('cliente.menu',
              htf.bold('Clientes'), cattributes => 'target="Left"'));
    htp.br;

    -- El menu de pedidos.
    htp.print(htf.bold('Pedidos'));
    htp.ulistOpen;
      htp.listItem(
        htf.anchor('pedido.drawListForm',
          htf.bold('Principal'),
          cattributes => 'target="Right"'
        )
      );
      htp.listItem(
        htf.anchor('pedido.drawInsertForm',
          htf.bold('Introducir'),
          cattributes => 'target="Right"'
        )
      );
--      htp.listItem(
--        htf.anchor('pedido.drawSearchForm',
--          htf.bold('Buscar'),
--          cattributes => 'target="Right"'
--        )
--      );
    htp.ulistClose;
    htp.br;

    htp.hr;

    -- Cierre de la pagina
    htp.bodyclose;
    htp.htmlClose;
  END menu;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWLISTFORM                                            **
  **                                                                   **
  ** Muestra el contenido de la tabla de pedidos.                      **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawListForm IS
    color   VARCHAR2(10);
    dir     VARCHAR2(200);
    cliente cliente_t;
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Listado de pedidos');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Tabla de datos
    htp.tableOpen('border=1 width=100% align=center bgcolor=#f0f0f0');
      htp.tablerowOpen(cattributes => 'bgcolor=#b0b0b0');
        htp.tableHeader('Pedido');
        htp.tableHeader('Cliente');
        htp.tableHeader('Fecha Pedido');
        htp.tableHeader('Fecha Entrega');
      htp.tablerowClose;
      -- Procesamos todos los elementos de pedido mediante un cursor
      -- implicito
      color := '#f0f0f0';
      FOR pedido IN (SELECT * FROM pedidos_tab ORDER BY numpedido) LOOP
        IF color = '#f0f0f0' THEN
          color := '#a5d0ff';
        ELSE
          color := '#f0f0f0';
        END IF;
	-- Derrefencia del cliente
        SELECT DEREF(pedido.clientref) INTO cliente FROM DUAL;

        -- Impresion de la fila
        htp.tablerowOpen(cattributes => 'bgcolor='||color);
          htp.tableData(htf.anchor('pedido.drawEditForm?edit='||pedido.numpedido,
                        pedido.numpedido), 'right');
          htp.tableData(cliente.nombre);
          htp.tableData(to_char(pedido.fechapedido,'DD-MM-YYYY'), 'center');
          htp.tableData(to_char(pedido.fechaenvio,'DD-MM-YYYY'), 'center');
        htp.tablerowClose;
      END LOOP;
    htp.tableClose;

    htp.bodyclose;
    htp.htmlClose;
  END drawListForm;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWINSERTFORM                                          **
  **                                                                   **
  ** Formulario de introduccion de un nuevo pedido.                    **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawInsertForm IS
    i   NUMBER;
    var VARCHAR2(10);
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Formulario de insercion de pedidos');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Formulario de introduccion de datos
    htp.formOpen('pedido.insertar', cmethod=>'get');

    htp.print(htf.bold('Nombre del cliente: '));
    htp.formSelectOpen('cli');
    FOR cliente IN (SELECT * FROM clientes_tab ORDER BY nombre) LOOP
	htp.formSelectOption(cliente.nombre,
                             cattributes => 'value = '||cliente.numclient);
    END LOOP;
    htp.formSelectClose;

    htp.tableOpen('border=0 width=100% align=center');
      htp.tablerowOpen;
        htp.tableData(htf.bold('Direccion envio:'), cattributes => 'colspan=2');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Calle:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('cal',75,75));
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Poblacion:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('pob',75,75));
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Provincia:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('pro',50,50));
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('C. Postal:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('zip',15,15));
      htp.tablerowClose;
    htp.tableClose;

    -- Formulario de accion
    htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
      htp.tablerowOpen;
	htp.tableData(htf.formSubmit(cvalue => 'Insertar'), 'center');
        htp.tableData(htf.formReset, 'center');
      htp.tablerowClose;
    htp.tableClose;
    htp.formClose;

    htp.bodyclose;
    htp.htmlClose;
  END drawInsertForm;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWEDITFORM                                            **
  **                                                                   **
  ** Edita un pedido                                                   **
  **                                                                   **
  ** Invoca: actualizar()                                              **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawEditForm (
     edit   IN NUMBER
  ) IS
    i        INTEGER;
    pedido   pedido_t;
    cliente  cliente_t;
    item     item_t;
    stock    stock_t;
  BEGIN
    -- Localizar el registro a editar
    SELECT VALUE(p) INTO pedido FROM pedidos_tab p WHERE p.numpedido = edit;

    -- Dereferenciamos el cliente
    SELECT DEREF(pedido.clientref) INTO cliente FROM DUAL;

    -- Generamos el formulario
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Edicion de un pedido');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    htp.formOpen('pedido.actualizar', cmethod=>'get');

    -- Primero, numpedido se pasa como un campo oculto
    htp.formHidden('cod',edit);

    htp.tableOpen('border=0 width=100% align=center');
      htp.tablerowOpen;
        htp.tableData(htf.bold('Cliente:'), cattributes => 'width=18%');
        htp.tableData(cliente.nombre,
                        cattributes => 'colspan=5');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData(htf.bold('Direccion de envio:'), cattributes => 'colspan=6');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Calle:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('cal',75,75,pedido.dir_envio.calle),
                      cattributes => 'colspan=5');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Poblacion:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('pob',75,75,pedido.dir_envio.poblacion),
                      cattributes => 'colspan=5');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Provincia:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('pro',50,50,pedido.dir_envio.provincia),
                      cattributes => 'colspan=5');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('C. Postal:', 'right', cattributes => 'width=18%');
        htp.tableData(htf.formText('zip',15,15,pedido.dir_envio.cod_zip),
                      cattributes => 'colspan=5');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Fecha pedido:','right', cattributes => 'width=18%');
        htp.tableData(htf.formText('fp',15,15,to_char(pedido.fechapedido,'DD-MM-YYYY')),
                      cattributes => 'colspan=5');
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Fecha envio:','right', cattributes => 'width=18%');
        htp.tableData(htf.formText('fe',15,15,to_char(pedido.fechaenvio,'DD-MM-YYYY')),
                      cattributes => 'colspan=5');
      htp.tablerowClose;
    htp.tableClose;
    -- Formulario de accion
    htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
      htp.tablerowOpen;
        htp.tableData(htf.formSubmit(cvalue => 'Modificar'), 'center');
      htp.tablerowClose;
    htp.tableClose;
    htp.formClose;

    htp.hr;

    -- Bloque dedicado a la lista de items
    htp.print(htf.bold('Items del pedido:'));
    htp.tableOpen('border=1 width=100% align=center bgcolor=#f0f0f0');
      htp.tablerowOpen(cattributes => 'bgcolor=#b0b0b0');
        htp.tableHeader('Numero');
        htp.tableHeader('Descripcion');
        htp.tableHeader('Cantidad');
        htp.tableHeader('Descuento');
        htp.tableHeader('Precio');
      htp.tablerowClose;
      -- Recorremos la lista de items
        FOR i IN 1..pedido.lista_item.COUNT LOOP
          item := pedido.lista_item(i);
          -- Derreferenciamos el elemento del stock
          SELECT DEREF(item.stockref) INTO stock FROM DUAL;
          -- Imprimimos la informacion
          htp.tablerowOpen;
            htp.tableData(i, 'right');
            htp.tableData(stock.descr);
            htp.tableData(item.cantidad, 'right');
            htp.tableData(item.descuento||'%', 'right');
            htp.tableData(to_char(stock.precio,'99G990D99'), 'right');
            htp.formClose;
          htp.tablerowClose;
        END LOOP;
        -- Una linea con el valor total...
        htp.tablerowOpen;
            htp.tableData(htf.bold('Importe total del pedido:'),'right', 
               cattributes => 'colspan=4');
	    htp.tableData(to_char(pedido.valor_total, '99G990D99'), 'right');
        htp.tablerowClose;
    htp.tableClose;

    htp.hr;
    -- Agregar nuevo item al pedido
    htp.print(htf.bold('Agregar nuevo item al pedido:'));
    htp.formOpen('pedido.agregaItem', cmethod => 'get');

    htp.print(htf.bold('Elemento del stock: '));
    htp.formHidden('cod',edit);
    htp.formSelectOpen('ite');
    FOR st IN (SELECT * FROM stock_tab ORDER BY descr) LOOP
	htp.formSelectOption(st.descr,
                             cattributes => 'value = '||st.numstock);
    END LOOP;
    htp.formSelectClose;
    htp.br;
    htp.print(htf.bold('Cantidad: '));
    htp.formText('can',10,10,'1');
    htp.br;
    htp.print(htf.bold('Descuento: '));
    htp.formText('des',10,10,'0');
    htp.br;
    -- Formulario de accion
    htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
      htp.tablerowOpen;
        htp.tableData(htf.formSubmit(cvalue => 'Agregar'), 'center');
      htp.tablerowClose;
    htp.tableClose;
    htp.formClose;

    htp.hr;
    -- Borrar el pedido
    htp.print(htf.bold('Borrar el pedido:'));
    htp.formOpen('pedido.borrar', cmethod => 'get');
    htp.formHidden('cod',edit);
    -- Formulario de accion
    htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
      htp.tablerowOpen;
        htp.tableData(htf.formSubmit(cvalue => 'Borrar'), 'center');
      htp.tablerowClose;
    htp.tableClose;
    htp.formClose;

    htp.bodyclose;
    htp.htmlclose;

    EXCEPTION
      WHEN OTHERS THEN
        showError('Elemento no existe',SQLERRM);
  END drawEditForm; 

  /**********************************************************************
  **                                                                   **
  ** Procedure INSERTAR                                                **
  **                                                                   **
  ** Introduce un nuevo elemento del clientes.                         **
  **                                                                   **
  **********************************************************************/
  PROCEDURE insertar (
     cli IN VARCHAR2,
     cal IN VARCHAR2,
     pob IN VARCHAR2,
     pro IN VARCHAR2,
     zip IN VARCHAR2
  ) IS
     refcliente REF cliente_t;
     dircliente   direccion_t;
  BEGIN
    -- Obtenemos la referencia al cliente y su direccion...
    SELECT REF(c), c.direccion
      INTO refcliente, dircliente
      FROM clientes_tab c 
     WHERE c.numclient = cli;

    -- Si la direccion suministrada es otra, usar esa...
    IF cal IS NOT NULL THEN
      dircliente := direccion_t(cal,pob,pro,zip);
    END IF;

    -- Creamos el nuevo registro. 
    INSERT INTO pedidos_tab 
    VALUES (
      pedido_seq.NEXTVAL,
      refcliente,
      SYSDATE,
      SYSDATE+15,
      lista_item_t(),
      dircliente
    );
    drawInsertForm;

    EXCEPTION
      WHEN OTHERS THEN
        showError('Imposible insertar el registro',SQLERRM);
  END insertar; 

  /**********************************************************************
  **                                                                   **
  ** Procedure AGREGAITEM                                              **
  **                                                                   **
  ** Introduce un nuevo item en la lista de items de un pedido.        **
  **                                                                   **
  **********************************************************************/
   PROCEDURE agregaItem (
     cod IN VARCHAR2,
     ite IN VARCHAR2,
     can IN VARCHAR2,
     des IN VARCHAR2
  ) IS
     stock  REF stock_t;
  BEGIN
    -- Obtenemos la referencia al stock
    SELECT REF(s) INTO stock FROM stock_tab s WHERE s.numstock = ite;

    -- Insertamos un nuevo elemento en la lista anidada.
    INSERT INTO THE (SELECT p.lista_item
                       FROM pedidos_tab p
                      WHERE p.numpedido = cod)
    VALUES (item_seq.NEXTVAL, stock, can, des);

    -- Volvemos al menu...
    drawEditForm(cod);

    EXCEPTION
      WHEN OTHERS THEN
        showError('Imposible insertar el nuevo item',SQLERRM);
  END agregaItem; 

  /**********************************************************************
  **                                                                   **
  ** Procedure BORRAR                                                  **
  **                                                                   **
  ** Elimina un pedido de la tabla de pedidos.                         **
  **                                                                   **
  **********************************************************************/
   PROCEDURE borrar (
     cod IN VARCHAR2
  ) IS
  BEGIN
    -- Borramos el registro
    DELETE FROM pedidos_tab WHERE numpedido = cod;

    -- Volvemos al menu principal
    drawListForm;

    EXCEPTION
      WHEN OTHERS THEN
        showError('Imposible borrar el pedido',SQLERRM);
  END borrar; 

  /**********************************************************************
  **                                                                   **
  ** Procedure ACTUALIZAR                                              **
  **                                                                   **
  ** Elimina un pedido de la tabla de pedidos.                         **
  **                                                                   **
  **********************************************************************/
   PROCEDURE actualizar (
     cod IN VARCHAR2,
     cal IN VARCHAR2,
     pob IN VARCHAR2,
     pro IN VARCHAR2,
     zip IN VARCHAR2,
     fp  IN VARCHAR2,
     fe  IN VARCHAR2
  ) IS
  BEGIN
    -- Actualizamos el registro
    UPDATE pedidos_tab
       SET dir_envio=direccion_t(cal,pob,pro,zip),
           fechapedido=to_date(fp,'DD-MM-YYYY'),
           fechaenvio=to_date(fe,'DD-MM-YYYY')
      WHERE numpedido = cod;

    -- Volvemos al menu de edicion.
    drawEditForm(cod);

    EXCEPTION
      WHEN OTHERS THEN
        showError('Imposible modificar el pedido',SQLERRM);
  END actualizar; 

 /**********************************************************************
  **                                                                   **
  ** Procedure showError                                               **
  **                                                                   **
  ** Muestra un mensaje de error.                                      **
  **                                                                   **
  **********************************************************************/
  PROCEDURE showError (
    mensaje IN VARCHAR2,
    mencod  IN VARCHAR2
  ) IS
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Error en el modulo de gestion de clientes');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Mostramos el mensaje de error
    htp.tableOpen('border=0 width=100% align=center bgcolor=#f0f0f0');
      htp.tablerowOpen;
        htp.tableData(htf.bold('<font size=+1>'||mensaje||'</font>'), 'center');
      htp.tablerowClose;
      htp.tablerowOpen;
	htp.tabledata('Error: '||mencod, 'left');
      htp.tablerowClose;
    htp.tableClose;

    htp.bodyclose;
    htp.htmlclose;
  END showError;
END;
/