CREATE OR REPLACE PACKAGE BODY stock AS
  /**********************************************************************
  **                                                                   **
  ** Procedure MENU                                                    **
  **                                                                   **
  ** Menu principal del paquete de gestion de la tabla de stocks       **
  **                                                                   **
  ** Invoca: Nada                                                      **
  **                                                                   **
  **********************************************************************/
  PROCEDURE menu IS
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Sistema de gestion de pedidos - Menu stock ');
    htp.headClose;
    htp.bodyOpen(
    cattributes => 'background="/icons/sgp/fondo_2.jpg"
                    text=#ffffff link=#ffffff vlink=#e8e8e8');

    htp.hr;
    -- El menu del paquete "stock"
    htp.print(htf.bold('<i>Stocks</i>'));
    htp.ulistOpen;
      htp.listItem(
        htf.anchor('stock.drawListForm',
          htf.bold('Principal'),
          cattributes => 'target="Right"'
        )
      );
      htp.listItem(
        htf.anchor('stock.drawInsertForm',
          htf.bold('Introducir'),
          cattributes => 'target="Right"'
        )
      );
      htp.listItem(
        htf.anchor('stock.drawSearchForm',
          htf.bold('Buscar'),
          cattributes => 'target="Right"'
        )
      );
    htp.ulistClose;
    htp.br;

    -- El menu de clientes
    htp.print(htf.anchor('cliente.menu',
              htf.bold('Clientes'), cattributes => 'target="Left"'));
    htp.br;

    -- El menu de pedidos.
    htp.print(htf.anchor('pedido.menu',
              htf.bold('Pedidos'), cattributes => 'target="Left"'));
    htp.br;

    htp.hr;

    -- Cierre de la pagina
    htp.bodyclose;
    htp.htmlClose;
  END menu;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWINSERTFORM                                          **
  **                                                                   **
  ** Formulario de introduccion de un nuevo elemento del stock.        **
  **                                                                   **
  ** Invoca: stock.insertar()                                          **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawInsertForm IS
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Formulario de insercion de elementos del stock');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Formulario de introduccion de datos
    htp.formOpen('stock.insertar', cmethod=>'get');
    htp.tableOpen('border=0 width=100% align=center');
      htp.tablerowOpen;
        htp.tableData('Descripcion:');
        htp.tableData(htf.formText('des',85,85));
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Precio:');
        htp.tableData(htf.formText('pre',10,10));
      htp.tablerowClose;
      htp.tablerowOpen;
        htp.tableData('Impuesto:');
        htp.tableData(htf.formText('imp',10,10));
      htp.tablerowClose;
    htp.tableClose;

    -- Formulario de accion
    htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
      htp.tablerowOpen;
   htp.tableData(htf.formSubmit(cvalue => 'Insertar'), 'center');
        htp.tableData(htf.formReset, 'center');
      htp.tablerowClose;
    htp.tableClose;
    htp.formClose;
    htp.bodyclose;
    htp.htmlClose;
  END drawInsertForm;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWLISTFORM                                            **
  **                                                                   **
  ** Muestra el contenido de la tabla de stocks.                       **
  **                                                                   **
  ** Invoca: stock.drawEditForm                                        **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawListForm IS
    total NUMBER;
    color VARCHAR2(10);
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Lista de elementos del stock');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Tabla de datos
    htp.tableOpen('border=1 width=100% align=center bgcolor=#f0f0f0');
      htp.tablerowOpen(cattributes => 'bgcolor=#b0b0b0');
        htp.tableHeader('Stock');
        htp.tableHeader('Descripcion');
        htp.tableHeader('Precio');
        htp.tableHeader('Tasa');
        htp.tableHeader('Total');
      htp.tablerowClose;

      -- Procesamos todos los elementos del stock mediante un cursor
      -- implicito
      color := '#f0f0f0';
      FOR elemento IN (SELECT * FROM stock_tab ORDER BY numstock) LOOP
        IF color = '#f0f0f0' THEN
          color := '#a5d0ff';
        ELSE
          color := '#f0f0f0';
        END IF;
        htp.tablerowOpen(cattributes => 'bgcolor='||color);
          htp.tableData(elemento.numstock, 'right');
          htp.tableData(htf.anchor('stock.drawEditForm?edit='||elemento.numstock,
             elemento.descr));
          htp.tableData(to_char(elemento.precio,'99G990D99'), 'right');
          htp.tableData(elemento.cod_tasa || '%', 'right');
          total := elemento.precio * (1 + 0.01*elemento.cod_tasa);
          htp.tableData(to_char(total,'99G990D99'), 'right');
        htp.tablerowClose;
      END LOOP;
    htp.tableClose;

    htp.bodyclose;
    htp.htmlClose;
  END drawListForm;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWSEARCHFORM                                          **
  **                                                                   **
  ** Formulario de busqueda de elementos del stock.                    **
  **                                                                   **
  ** Invoca: buscar()                                                  **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawSearchForm IS
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Busqueda de elementos del stock');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Formulario de introduccion de datos
    htp.formOpen('stock.buscar', cmethod=>'get');
    htp.tableOpen('border=0 width=100% align=center');
      htp.tablerowOpen;
          htp.tableData(
            htf.formSelectOpen('campo1')     ||
            htf.formSelectOption('descr')    ||
            htf.formSelectOption('numstock') ||
            htf.formSelectOption('precio')   ||
            htf.formSelectClose, 'center'
          );
          htp.tableData(
            htf.formSelectOpen('oper1')  ||
            htf.formSelectOption('=')    ||
            htf.formSelectOption('!=')   ||
            htf.formSelectOption('>')    ||
            htf.formSelectOption('<')    ||
            htf.formSelectOption('>=')   ||
            htf.formSelectOption('<=')   ||
            htf.formSelectOption('LIKE') ||
            htf.formSelectClose, 'center'
          );
          htp.tableData(htf.formText('arg1',75,75), 'center');
        htp.tablerowClose;
        htp.tablerowOpen;
   htp.tableData(
            htf.formSelectOpen('glue')  ||
            htf.formSelectOption('AND') ||
            htf.formSelectOption('OR')  ||
            htf.formSelectClose, 'center', cattributes => 'colspan=3'
          );
        htp.tablerowClose;
        htp.tablerowOpen;
      htp.tablerowOpen;
          htp.tableData(
            htf.formSelectOpen('campo2')     ||
            htf.formSelectOption('descr')    ||
            htf.formSelectOption('numstock') ||
            htf.formSelectOption('precio')   ||
            htf.formSelectClose, 'center'
          );
          htp.tableData(
            htf.formSelectOpen('oper2')  ||
            htf.formSelectOption('=')    ||
            htf.formSelectOption('!=')   ||
            htf.formSelectOption('>')    ||
            htf.formSelectOption('<')    ||
            htf.formSelectOption('>=')   ||
            htf.formSelectOption('<=')   ||
            htf.formSelectOption('LIKE') ||
            htf.formSelectClose, 'center'
          );
          htp.tableData(htf.formText('arg2',75,75), 'center');
        htp.tablerowClose;
    htp.tableClose;

    -- Formulario de accion
    htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
      htp.tablerowOpen;
   htp.tableData(htf.formSubmit(cvalue => 'Buscar'), 'center');
        htp.tableData(htf.formReset, 'center');
      htp.tablerowClose;
    htp.tableClose;
    htp.formClose;

    htp.bodyclose;
    htp.htmlClose;
  END drawSearchForm;

  /**********************************************************************
  **                                                                   **
  ** Procedure INSERTAR                                                **
  **                                                                   **
  ** Introduce un nuevo elemento del stock.                            **
  **                                                                   **
  **********************************************************************/
  PROCEDURE insertar (
     des    IN VARCHAR2,
     pre    IN NUMBER,
     imp    IN NUMBER
  ) IS
  BEGIN

    INSERT INTO stock_tab VALUES(stock_seq.NEXTVAL,des,pre,imp);
    drawInsertForm;

    EXCEPTION
      WHEN OTHERS THEN
        showError('Imposible insertar el registro',SQLERRM);
  END insertar;

  /**********************************************************************
  **                                                                   **
  ** Procedure BUSCAR                                                  **
  **                                                                   **
  ** Buscar tuplas en la tabla de stocks utilizando SQL dinamico.      **
  **                                                                   **
  **********************************************************************/
  PROCEDURE buscar (
     campo1  IN VARCHAR2,
     oper1   IN VARCHAR2,
     arg1    IN VARCHAR2,
     glue    IN VARCHAR2,
     campo2  IN VARCHAR2,
     oper2   IN VARCHAR2,
     arg2    IN VARCHAR2
  ) IS
    TYPE cur_typ IS REF CURSOR;
    query        VARCHAR2(200) := '';
    f1           VARCHAR2(100);
    f2           VARCHAR2(100);
    color        VARCHAR2(10);
    total        NUMBER;
    stock_cur    cur_typ;
    codigo       stock_tab.numstock%TYPE;
    descrip      stock_tab.descr%TYPE;
    precio       stock_tab.precio%TYPE;
    impuesto     stock_tab.cod_tasa%TYPE;
  BEGIN
    IF arg1 IS NULL THEN
      -- No se ha suministrado argumento, volvemos a busquedas...
      drawSearchForm;
    ELSE
      -- Comenzamos a escribir la primera busqueda
      IF oper1 = 'LIKE' THEN
        -- Tratamiento para el operador like
        -- Primero condicionamos arg1: eliminar espacios al principio y al
        -- final y pasamos la cadena a minusculas.
        f1 := '%' || LOWER(TRIM(BOTH ' ' FROM arg1)) || '%';
        query := 'SELECT * FROM stock_tab WHERE LOWER(' || campo1 || ') ' || oper1 || ' :1';
      ELSE
        -- La busqueda en este caso es mas sencilla
        f1 := arg1;
        query := 'SELECT * FROM stock_tab WHERE ' || campo1 || ' ' || oper1 || ' :1';
      END IF;

      -- Existe un segundo criterio de busqueda?
      IF arg2 IS NOT NULL THEN
        -- Comenzamos a escribir la segunda busqueda
        IF oper2 = 'LIKE' THEN
          -- Tratamiento para el operador like
          -- Primero condicionamos arg2: eliminar espacios al principio y al
          -- final y pasamos la cadena a minusculas.
          f2 := '%' || LOWER(TRIM(BOTH ' ' FROM arg2)) || '%';
          query := query || ' ' || glue || ' LOWER(' || campo2 || ') ' || oper2 || ' :2';
        ELSE
        -- La busqueda en este caso es mas sencilla
          f2 := arg2;
          query := query || ' ' || glue || ' ' || campo2 || ' ' || oper2 || ' :2';
        END IF;
      END IF;

      -- Abrimos el cursor segun tengamos uno o dos criterios de busqueda
      IF arg2 IS NOT NULL THEN
        OPEN stock_cur FOR query USING f1,f2;
      ELSE
        OPEN stock_cur FOR query USING f1;
      END IF;

      -- Procesamos la consulta
      htp.htmlOpen;
      htp.headOpen;
      htp.title('Resultados de la busqueda');
      htp.headClose;
      htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');
      -- Tabla de datos
      -- Cabecera
      htp.tableOpen('border=1 width=100% align=center bgcolor=#f0f0f0');
        htp.tablerowOpen(cattributes => 'bgcolor=#b0b0b0');
          htp.tableHeader('Stock');
          htp.tableHeader('Descripcion');
          htp.tableHeader('Precio');
          htp.tableHeader('Tasa');
          htp.tableHeader('Total');
        htp.tablerowClose;
        -- Procesamos todos los elementos del stock que cumplen la
        -- condicion mediante un cursor explicito generado dinamicamente
        color := '#f0f0f0';
        LOOP
          FETCH stock_cur INTO codigo, descrip, precio, impuesto;
          EXIT WHEN stock_cur%NOTFOUND;

          IF color = '#f0f0f0' THEN
            color := '#a5d0ff';
          ELSE
            color := '#f0f0f0';
          END IF;

          htp.tablerowOpen(cattributes => 'bgcolor='||color);
            htp.tableData(codigo, 'right');
            htp.tableData(htf.anchor('stock.drawEditForm?edit='||codigo,descrip));
            htp.tableData(to_char(precio,'99G990D99'), 'right');
            htp.tableData(impuesto || '%', 'right');
            total := precio * (1 + 0.01*impuesto);
            htp.tableData(to_char(total,'99G990D99'), 'right');
          htp.tablerowClose;
        END LOOP;
      CLOSE stock_cur;
      htp.tableClose;

      htp.bodyclose;
      htp.htmlClose;
    END IF;
    EXCEPTION
      WHEN OTHERS THEN
        showError('Error en la busqueda',SQLERRM);
  END buscar;

  /**********************************************************************
  **                                                                   **
  ** Procedure DRAWEDITFORM                                            **
  **                                                                   **
  ** Edita un elemento del stock                                       **
  **                                                                   **
  ** Invoca: actualizar()                                              **
  **                                                                   **
  **********************************************************************/
  PROCEDURE drawEditForm (
     edit   IN NUMBER
  ) IS
    descrip  stock_tab.descr%TYPE;
    precio   stock_tab.precio%TYPE;
    impuesto stock_tab.cod_tasa%TYPE;
  BEGIN
    -- Localizar el registro a editar
    SELECT s.descr, s.precio, s.cod_tasa
      INTO descrip,precio,impuesto
      FROM stock_tab s
     WHERE s.numstock = edit;

    -- Generamos el formulario
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Edicion de un elemento del stock');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    htp.formOpen('stock.actualizar', cmethod=>'get');

     -- Primero, numstock se pasa como un campo oculto
     htp.formHidden('cod',edit);

     htp.tableOpen('border=0 width=100% align=center');
      htp.tablerowOpen;
        htp.tableData('Descripcion:');
        htp.tableData(htf.formText('des',85,85,descrip));
    htp.tablerowClose;
    htp.tablerowOpen;
      htp.tableData('Precio:');
      htp.tableData(htf.formText('pre',10,10,precio));
    htp.tablerowClose;
    htp.tablerowOpen;
      htp.tableData('Impuesto:');
      htp.tableData(htf.formText('imp',10,10,impuesto));
    htp.tablerowClose;
  htp.tableClose;

  -- Formulario de accion
  htp.tableOpen('border=1 width=100% bgcolor=#f0f0f0 align=center');
    htp.tablerowOpen;
      htp.tableData(htf.formSubmit('opcion', 'Modificar'), 'center');
      htp.tableData(htf.formSubmit('opcion', 'Borrar'), 'center');
    htp.tablerowClose;
  htp.tableClose;
  htp.formClose;

  htp.bodyclose;
  htp.htmlClose;

  EXCEPTION
    WHEN OTHERS THEN
      showError('Elemento no existe',SQLERRM);
  END drawEditForm;

  /**********************************************************************
  **                                                                   **
  ** Procedure ACTUALIZAR                                              **
  **                                                                   **
  ** Edita un elemento del stock                                       **
  **                                                                   **
  **********************************************************************/
  PROCEDURE actualizar (
     cod    IN NUMBER,
     des    IN VARCHAR2,
     pre    IN NUMBER,
     imp    IN NUMBER,
     opcion IN VARCHAR2
  ) IS
  BEGIN
    IF opcion = 'Modificar' THEN
      UPDATE stock_tab
         SET descr=des,precio=pre,cod_tasa=imp
       WHERE numstock = cod;
    ELSIF opcion = 'Borrar' THEN
      DELETE FROM stock_tab WHERE numstock = cod;
    ELSE
       drawEditForm(cod);
    END IF;
    drawListForm;
  END actualizar;

  /**********************************************************************
  **                                                                   **
  ** Procedure showError                                               **
  **                                                                   **
  ** Muestra un mensaje de error.                                      **
  **                                                                   **
  **********************************************************************/
  PROCEDURE showError (
    mensaje IN VARCHAR2,
    mencod  IN VARCHAR2
  ) IS
  BEGIN
    htp.htmlOpen;
    htp.headOpen;
    htp.title('Error en el modulo de gestion de stocks');
    htp.headClose;
    htp.bodyOpen(cattributes => 'bgcolor=#e8e8e8');

    -- Mostramos el mensaje de error
    htp.tableOpen('border=0 width=100% align=center bgcolor=#f0f0f0');
      htp.tablerowOpen;
        htp.tableData(htf.bold('<font size=+1>'||mensaje||'</font>'), 'center');
      htp.tablerowClose;
      htp.tablerowOpen;
   htp.tabledata('Error: '||mencod, 'left');
      htp.tablerowClose;
    htp.tableClose;

    htp.bodyclose;
    htp.htmlClose;
  END showError;
END;
/
